MATRIX worldviewproj;	

Technique T0 {
/*pass P0
{
    ZWriteEnable=false;
}*/
pass p1
{
    VertexShaderConstant[0] = <worldviewproj>;
    FogEnable=0;
    VertexShader = decl
    {
        stream 0;
        float v0[3]; // Position
        float v3[3]; // Normal
        float v7[2]; // Texture Coord1
        float v8[3]; // Tangent
        float v9[3]; // Binormal
    } asm {
        vs.1.1
        def c4, 1.0, 0.0, 0.0, 1.0	//Light direction
        def c5, 0.5, 0.5, 0.5, 1.0
        m4x4 oPos, v0, c0   // transform vertices by view/projection matrix

        dp3 r1.x, v8, c4
        dp3 r1.y, v9, c4
        dp3 r1.z, v3, c4

        dp3 r1.w, r1, r1
        rsq r1.w, r1.w
        mul r1, r1, r1.w

        mad oT2.xyz, r1, c5, c5	//Use texture registor for output because it's more accurate
        mov oT2.w, c5.w

        mov oT0.xy, v7
        mov oT1.xy, v7
    };

    PixelShader = asm
    {
        ps.1.1
        def c0, 0, 1, 0, 1.0
        tex t0  // Sample texture
        tex t1  // Sample normal map
        texcoord t2 //Retrieve the transformed lighting thingy
        mov r0,t1
        dp3 r0,t1_bx2,t2_bx2; // Dot(light,normal) 
        mul r0.rgb,t0,r0          // Modulate against base color
        +mov r0.a,c0
    };
}
}
